<?php /**
 * @file
 * Contains \Drupal\miniorange_ldap\Controller\DefaultController.
 */

namespace Drupal\ldap_auth\Controller;
//require_once('../../../ldap_auth.install');
use Drupal\Core\Controller\ControllerBase;
use Drupal\user\Entity\User;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpFoundation\RedirectResponse;

include_once ("ldap_auth.module");
class miniorange_ldapController extends ControllerBase {
    public function ldap_auth_feedback_func()
    {
        $res = '';
        $res = json_encode($_POST);
        $outarr = json_decode($res, TRUE);
        \Drupal::configFactory()->getEditable('ldap_auth.settings')->set('miniorange_ldap_feedback_status', 'received')->save();

        $_SESSION['mo_other']="False";
        global $base_url;
        $reason=$outarr['reason'];
        $q_feedback=$outarr['q_feedback'];

        $message = 'Reason: '.$reason.'<br>'.'Feedback: '.$q_feedback;
        $url = 'https://login.xecurify.com/moas/api/notify/send';
        $chi = curl_init($url);
        $email =\Drupal::config('ldap_auth.settings')->get('miniorange_ldap_customer_admin_email');
        if(empty($email)) {
            $email = $outarr['email'];
        }
        if(valid_email_address($email)) {
            $phone = \Drupal::config('ldap_auth.settings')->get('miniorange_ldap_customer_admin_phone');
            $customerKey = \Drupal::config('ldap_auth.settings')->get('miniorange_ldap_customer_id');
            $apikey = \Drupal::config('ldap_auth.settings')->get('miniorange_ldap_customer_api_key');
            if ($customerKey == '') {
                $customerKey = "16555";
                $apikey = "fFd2XcvTGDemZvbw1bcUesNJWEqKbbUq";
            }
            $currentTimeInMillis = self::get_oauth_timestamp();
            $stringToHash = $customerKey . $currentTimeInMillis . $apikey;
            $hashValue = hash("sha512", $stringToHash);
            $customerKeyHeader = "Customer-Key: " . $customerKey;
            $timestampHeader = "Timestamp: " . $currentTimeInMillis;
            $authorizationHeader = "Authorization: " . $hashValue;
            $fromEmail = $email;
            $subject = "Drupal 8 Active Directory Integration / LDAP Integration - NTLM & Kerberos Login Feedback";
            $query = '[Drupal 8 Active Directory Integration / LDAP Integration - NTLM & Kerberos Login]: ' . $message;
            $content = '<div >Hello, <br><br>Company :<a href="' . $_SERVER['SERVER_NAME'] . '" target="_blank" >' . $_SERVER['SERVER_NAME'] . '</a><br><br>Phone Number :' . $phone . '<br><br>Email :<a href="mailto:' . $fromEmail . '" target="_blank">' . $fromEmail . '</a><br><br>Query :' . $query . '</div>';
            $fields = array(
                'customerKey' => $customerKey,
                'sendEmail' => true,
                'email' => array(
                    'customerKey' => $customerKey,
                    'fromEmail' => $fromEmail,
                    'fromName' => 'miniOrange',
                    'toEmail' => 'drupalsupport@xecurify.com',
                    'toName' => 'drupalsupport@xecurify.com',
                    'subject' => $subject,
                    'content' => $content
                ),
            );

            $field_string = json_encode($fields);
            curl_setopt($chi, CURLOPT_FOLLOWLOCATION, true);
            curl_setopt($chi, CURLOPT_ENCODING, "");
            curl_setopt($chi, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($chi, CURLOPT_AUTOREFERER, true);
            curl_setopt($chi, CURLOPT_SSL_VERIFYPEER, false);    # required for https urls
            curl_setopt($chi, CURLOPT_MAXREDIRS, 10);
            curl_setopt($chi, CURLOPT_HTTPHEADER, array("Content-Type: application/json", $customerKeyHeader,
                $timestampHeader, $authorizationHeader));
            curl_setopt($chi, CURLOPT_POST, true);
            curl_setopt($chi, CURLOPT_POSTFIELDS, $field_string);
            $content = curl_exec($chi);
            if (curl_errno($chi)) {
                return json_encode(array("status" => 'ERROR', 'statusMessage' => curl_error($chi)));
            }
            curl_close($chi);
        }
        return new Response();
}
    /**
     * This function is used to get the timestamp value
     */
    public function get_oauth_timestamp() {
        $url = 'https://login.xecurify.com/moas/rest/mobile/get-timestamp';
        $ch  = curl_init( $url );
        curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, true );
        curl_setopt( $ch, CURLOPT_ENCODING, "" );
        curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
        curl_setopt( $ch, CURLOPT_AUTOREFERER, true );
        curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, false );
        curl_setopt( $ch, CURLOPT_SSL_VERIFYHOST, false ); // required for https urls
        curl_setopt( $ch, CURLOPT_MAXREDIRS, 10 );
        curl_setopt( $ch, CURLOPT_POST, true );
        $content = curl_exec( $ch );
        if ( curl_errno( $ch ) ) {
            echo 'Error in sending curl Request';
            exit ();
        }
        curl_close( $ch );
        if(empty( $content )){
            $currentTimeInMillis = round( microtime( true ) * 1000 );
            $currentTimeInMillis = number_format( $currentTimeInMillis, 0, '', '' );
        }
        return empty( $content ) ? $currentTimeInMillis : $content;
    }

    public function uninst_mod() {
        global $base_url;
        \Drupal::service('module_installer')->uninstall(['ldap_auth']);
        $uninstall_redirect = $base_url.'/admin/modules';
        $response = new RedirectResponse($uninstall_redirect);
        $response->send();
        return new Response();
    }

  function test_mo_config()
  {
	$login_with_ldap = \Drupal::config('ldap_auth.settings')->get('miniorange_ldap_enable_ldap');
  	if($login_with_ldap != '1')
	  {
			echo "You have not select the <strong>Login with LDAP</strong> option in the <strong>LDAP Configurations</strong> tab. Please do so in order to perform the test.";exit;
	  }
    $username = \Drupal::config('ldap_auth.settings')->get('miniorange_ldap_server_account_username');
		$password = \Drupal::config('ldap_auth.settings')->get('miniorange_ldap_server_account_password');

	$auth_response = ldap_login($username, $password);
    if($auth_response->statusMessage == "SUCCESS")
	  {
		echo "<br><br><div style='color: blue;background-color: #DFF2BF;padding-left: 15px;border-radius:8px;'><br><br><h2>You have successfully configured your LDAP settings.<br>
		    Enable <b>LDAP Login</b> at the top and then Logout from your Drupal site and login again with your LDAP credentials.</h2><br><br></div>";exit;
	  }
	else if($auth_response->statusMessage =="USER_NOT_EXIST")
	  {
		echo "<br><br><div style='color: red; background-color: #DFF2BF;padding-left: 15px;border-radius:8px; margin: 10px 0;padding: 10px;border-radius: 3px 3px 3px 3px;padding-left: 15px;border-radius:8px;'><br><br><h2>This user does not exists.<br>
		Please check your configurations or contact the administrator</h2><br><br></div>";exit;
	  }
	else
	  {
			return json_encode(array("statusCode"=>'ERROR','statusMessage'=>'Invalid Password. Please check your password and try again.'));
	  }
  }

  function test_ldap_conn()
  {
	  $login_with_ldap = \Drupal::config('ldap_auth.settings')->get('miniorange_ldap_enable_ldap');
	  if($login_with_ldap != '1')
	  {
		echo "You have not select the <strong>Login with LDAP</strong> option in the <strong>LDAP Configurations</strong> tab. Please do so in order to perform the test.";exit;
	  }
	  $ldapconn = getConnection();
	  if($ldapconn)
	  {
		  ldap_set_option($ldapconn, LDAP_OPT_PROTOCOL_VERSION, 3);
		  ldap_set_option($ldapconn, LDAP_OPT_REFERRALS, 0);
  		$ldap_bind_dn = \Drupal::config('ldap_auth.settings')->get('miniorange_ldap_server_account_username');
	  	$ldap_bind_password =\Drupal::config('ldap_auth.settings')->get('miniorange_ldap_server_account_password');
		  if(\Drupal::config('ldap_auth.settings')->get('miniorange_ldap_enable_tls') != 0)
			  ldap_start_tls($ldapconn);
		  $bind = @ldap_bind($ldapconn, $ldap_bind_dn, $ldap_bind_password);
		  $err = ldap_error($ldapconn);
		  if(strtolower($err) != 'success'){
			  echo "There seems to be an error trying to contact your LDAP server. Please check your configurations or contact the administrator for the same."; exit;
		  }
		  else{
			  echo "<div style='background-color: lightblue;height: 100%;width:100%;'>
			  <div style='background-color:lightgreen;text-align: center;margin-top: 30%;padding: 20px;color:maroon'>Congratulations!, you were successfully able to connect to your LDAP Server</div>
			  </div>";exit;
		  }
	  }
	  else{
		  print_r("It seems that the LDAP server you saved is not correct.");exit;
	  }
  }
}