<?php
/**
 * @file
 * Contains Attribute for miniOrange Login with NTLM Module.
 */

 /**
 * Showing Settings form.
 */
namespace Drupal\ldap_auth\Form;

use Drupal\Core\Form\FormBase;
use Drupal\ldap_auth\MiniorangeLDAPSupport;

class AttributeMapping extends FormBase {
  public function getFormId() {
    return 'miniorange_ldap_attrmapping';
  }
 public function buildForm(array $form, \Drupal\Core\Form\FormStateInterface $form_state)
 {
  $attachments['#attached']['library'][] = 'ldap_auth/ldap_auth.admin';
  $form['markup_library'] = array(
      '#attached' => array(
          'library' => array(
              "ldap_auth/ldap_auth.oauth_config",
              "ldap_auth/ldap_auth.admin",
              "ldap_auth/ldap_auth.testconfig",
          )
      ),
  );
  \Drupal::configFactory()->getEditable('ldap_auth.settings')->set('miniorange_ldap_disabled', FALSE)->save();

  $form['#prefix'] = '<div class="ui_text">';
  $form['#suffix'] = '</div>';

    $form['miniorange_ldap_div_1'] = array(
      '#prefix' => "<div class='subdiv_ui'>",
        '#suffix' => "</div><br>",
      '#markup' => "
        <div style='background-color: rgb(241,241,241) ; padding: 20px'>
            <div style='background-color: white; padding: 10px ;margin-left: 20px; width: 70%' id='enable_ldap'>
            <h2>Attribute Mapping <i>(Available in the Premium Version of the Plugin)</i></h2><br>
            <p>Enter the LDAP attribute names for Email, Phone, First Name and Last Name attributes</p>
            </div>
      ",
    );
    $form['miniorange_ldap_email_attr'] = array(
      '#type' => 'textfield',
      '#title' => t('Email Attribute:'),
      '#disabled' => true,
      '#prefix' => "<div class='subdiv_ui'>",
      '#suffix' => "</div>",
      '#id' => 'mo_ldap_email_attr',
      '#attributes' => array('placeholder' => 'Enter Username'),
  );
  $form['miniorange_ldap_phone_attr'] = array(
    '#type' => 'textfield',
    '#title' => t('Phone :'),
    '#disabled' => true,
    '#prefix' => "<div class='subdiv_ui'>",
    '#suffix' => "</div>",
    '#id' => 'mo_ldap_email_attr',
    '#attributes' => array('placeholder' => 'Enter phone'),
);
$form['miniorange_ldap_fname_attr'] = array(
  '#type' => 'textfield',
  '#title' => t('First Name:'),
  '#disabled' => true,
  '#prefix' => "<div class='subdiv_ui'>",
  '#suffix' => "</div>",
  '#id' => 'mo_ldap_email_attr',
  '#attributes' => array('placeholder' => 'Enter first name'),
);
$form['miniorange_ldap_lname_attr'] = array(
  '#type' => 'textfield',
  '#title' => t('Last Name:'),
  '#disabled' => true,
  '#prefix' => "<div class='subdiv_ui'>",
  '#suffix' => "</div>",
  '#id' => 'mo_ldap_email_attr',
  '#attributes' => array('placeholder' => 'Enter last name'),
);
$form['miniorange_ldap_contact_ldap_server']= array(
  '#markup' => "<div class ='subdiv_ui'>
  <div id='base_Url' name='base_Url' data='". $base_url."'></div>
 <a id='ping_server' class='btn btn-primary btn-sm' disabled style='padding:6px 12px;'>Test Configurations</a>
  </div>",
);
    $form['miniorange_ldap_div_2'] = array(
      '#prefix' => "</div><br><div class='subdiv_ui'>",
        '#suffix' => "</div><br>",
      '#markup' => "
      <div style='background-color: rgb(241,241,241) ; padding: 20px'>
            <div style='background-color: white; padding: 10px ;margin-left: 20px; width: 70%' id='enable_ldap'>
            <h2>Test Attribute Mapping Configuration <i>(Available in the Premium Version of the Plugin)</i></h2><br>
            </div>
      ",
    );
    $form['miniorange_ldap_username_attr'] = array(
      '#type' => 'textfield',
      '#title' => t('Username Attribute:'),
      '#disabled' => true,
      '#prefix' => "<div class='subdiv_ui'>",
      '#suffix' => "</div>",
      '#id' => 'mo_ldap_email_attr',
      '#attributes' => array('placeholder' => 'Enter Username'),
  );
  $form['miniorange_ldap_contact_server']= array(
    '#markup' => "<div class ='subdiv_ui'>
    <div id='base_Url' name='base_Url' data='". $base_url."'></div>
   <a id='ping_server' class='btn btn-primary btn-sm' disabled style='padding:6px 12px;'>Test Configurations</a>
    </div>",
  );
        return $form;
  }
  public function submitForm(array &$form, \Drupal\Core\Form\FormStateInterface $form_state)
  {

  }
}