<?php
/**
 * @file
 * Contains Licensing information for miniOrange SAML Login Module.
 */

 /**
 * Showing Licensing form info.
 */
namespace Drupal\ldap_auth\Form;
use Drupal\Core\Form\FormBase;
use Drupal\ldap_auth\MiniorangeLDAPSupport;

class MiniorangeLicensing extends FormBase {

public function getFormId() {
    return 'miniorange_ldap_licensing';
  }

public function buildForm(array $form, \Drupal\Core\Form\FormStateInterface $form_state)
{
    $form['markup_library'] = array(
        '#attached' => array(
            'library' => array(
                "ldap_auth/miniorange_ldap.admin",
                "ldap_auth/miniorange_ldap.style_settings",
                "ldap_auth/miniorange_ldap.main",

            )
        ),
      );
      $form['miniorange_ldap_license'] = array(
          '#markup' => '<html lang="en">
          <head>
            <meta charset="utf-8">
            <meta name="viewport" content="width=device-width, initial-scale=1">
            <!-- Main Style -->
            <link rel="stylesheet" type="text/css" href="assets/css/main.css">

            <!--Icon Fonts-->
            <link rel="stylesheet" media="screen" href="assets/fonts/font-awesome/font-awesome.min.css" />

          </head>

        <body>
         <!-- Pricing Table Section -->
        <section id="pricing-table">
            <div class="container">
                <div class="row">
                    <div class="pricing">
                        <div>
                        <div class="pricing-table class_inline">
                                <div class="pricing-header">
                                    <h2 class="pricing-title">Features</h2>
                                </div>

                                <div class="pricing-list">
                                    <ul>
                                        <li>Unlimited Authentications</li>
                                        <li>Single LDAP Directory Configuration</li>
                                        <li>Search User by Single Attribute</li>
                                        <li>Single Search Base</li>
                                        <li>Attribute Mapping</li>
                                        <li>User Auto-registration</li>
                                        <li>Role Mapping</li>
                                        <li>TLS Connection</li>
                                        <li>Drupal to LDAP updates on user profile</li>
                                        <li>NTLM & Kerberos Authentication</li>
                                        <li>Support for Custom Integration</li>
                                    </ul>
                                </div>
                            </div>
                        <div class="pricing-table class_inline">
                                <div class="pricing-header">
                                    <p class="pricing-title">Free</p>
                                    <p class="pricing-rate"><sup>$</sup> 0 </p>
                                    <a href="https://www.miniorange.com/contact" target="_blank" class="btn btn-custom">Contact Us</a>
                                </div>

                                <div class="pricing-list">
                                    <ul>
                                        <li>&#x2714;</li>
                                        <li>&#x2714;</li>
                                        <li>&#x2714;</li>
                                        <li>&#x2714;</li>
                                        <li>Username Mapping </li>
                                        <li>&#x2714; </li>
                                        <li> </li>
                                        <li> </li>
                                        <li> </li>
                                        <li> </li>
                                        <li> </li>
                                    </ul>
                                </div>
                            </div>


                            <div class="pricing-table class_inline">
                            <div class="pricing-header">
                                <p class="pricing-title">Standard</p>
                                <p class="pricing-rate"><sup>$</sup> 149 </p>
                                <a href="https://www.miniorange.com/contact" target="_blank" class="btn btn-custom">Contact Us</a>
                            </div>

                            <div class="pricing-list">
                                <ul>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>&#x2714;</li>
                                    <li>Custom Mapping</li>
                                    <li>&#x2714;</li>
                                    <li>Basic</li>
                                    <li>&#x2714;</li>
                                </ul>
                            </div>
                        </div>
                        <div class="pricing-table class_inline">
                                <div class="pricing-header">
                                    <p class="pricing-title">Premium</p>
                                    <p class="pricing-rate"><sup>$</sup> 249 </p>
                                    <a href="https://www.miniorange.com/contact" target="_blank" class="btn btn-custom">Contact Us</a>
                                </div>

                                <div class="pricing-list">
                                    <ul>
                                        <li>&#x2714;</li>
                                        <li>&#x2714;</li>
                                        <li>Custom Search Filter</li>
                                        <li>Multiple Search Bases</li>
                                        <li>Custom Mapping</li>
                                        <li>&#x2714;</li>
                                        <li>Advanced</li>
                                        <li>&#x2714;</li>
                                        <li>&#x2714;</li>
                                        <li>&#x2714;</li>
                                        <li>&#x2714;</li>
                                    </ul>
                                </div>
                                </div>
                        </div>
                    </div>
                </div>
            </div>
        </section>
        <!-- Pricing Table Section End -->
        </body>
        </html>',
      );

          return $form;

     }

      public function submitForm(array &$form, \Drupal\Core\Form\FormStateInterface $form_state) {

      }


  function saved_support($form, &$form_state)
  {
      $email = $form['miniorange_saml_email_address_support']['#value'];
      $phone = $form['miniorange_saml_phone_number_support']['#value'];
      $query = $form['miniorange_saml_support_query_support']['#value'];
      $support = new MiniorangeLDAPSupport($email, $phone, $query);
      $support_response = $support->sendSupportQuery();
      if ($support_response) {
          drupal_set_message(t('Support query successfully sent'));
      } else {
          drupal_set_message(t('Error sending support query'), 'error');
      }
  }


 }

