<?php
/**
 * @file
 * Contains Attribute for miniOrange Login with NTLM Module.
 */

 /**
 * Showing Settings form.
 */
namespace Drupal\ldap_auth\Form;

use Drupal\Core\Form\FormBase;
use Drupal\ldap_auth\MiniorangeLDAPSupport;

class RoleMapping extends FormBase {
  public function getFormId() {
    return 'miniorange_ldap_attrmapping';
  }
 public function buildForm(array $form, \Drupal\Core\Form\FormStateInterface $form_state)
 {
  $attachments['#attached']['library'][] = 'ldap_auth/ldap_auth.admin';
  $form['markup_library'] = array(
      '#attached' => array(
          'library' => array(
              "ldap_auth/ldap_auth.oauth_config",
              "ldap_auth/ldap_auth.admin",
              "ldap_auth/ldap_auth.testconfig",
          )
      ),
  );
    \Drupal::configFactory()->getEditable('ldap_auth.settings')->set('miniorange_ldap_disabled', FALSE)->save();
  $form['#prefix'] = '<div class="ui_text">';
  $form['#suffix'] = '</div>';

    $form['miniorange_ldap_div_1'] = array(
      '#prefix' => "<div class='subdiv_ui'>",
        '#suffix' => "</div><br>",
      '#markup' => "
        <div style='background-color: rgb(241,241,241) ; padding: 20px'>
            <div style='background-color: white; padding: 10px ;margin-left: 20px; width: 70%' id='enable_ldap'>
            <h2>LDAP Groups to Drupal User Role Mapping <i>(Available in the Premium Version of the plugin)</i></h2><br>
            </div>
      ",
    );
    $form['miniorange_ldap_enable_tls'] = array(
      '#type' => 'checkbox',
      '#prefix' => "<div class='subdiv_ui'>",
      '#suffix' => "</div>",
      '#id' => 'check',
      '#disabled' => true,
      '#description' => 'Enabling Role Mapping will automatically map Users from LDAP Groups to below selected Drupal Role. Role mapping will not be applicable for primary admin of Drupal.',
      '#title' => t('Enable Role Mapping'),
      '#default_value' =>\Drupal::config('ldap_auth.settings')->get('miniorange_ldap_enable_tls'),
  );
  $mrole= user_role_names(TRUE);
   $form['miniorange_ldap_default_mapping'] = array(
    '#type' => 'select',
    '#id' => 'miniorange_oauth_client_app',
	'#title' => t('Select Default Role'),
  '#options' => $mrole,
  '$description' => 'Default role will be assigned to all users for which mapping is not specified.',
	'#default_value' => 'Authenticated User',
  '#disabled' => true,
   );
   $form['miniorange_ldap_enable_group_name'] = array(
    '#type' => 'textfield',
    '#prefix' => "<table><tr><td><div class='subdiv_ui'>",
    '#suffix' => "</div></td>",
    '#id' => 'check',
    '#disabled' => true,
    '#description' => 'Specify attribute which stores group names to which LDAP Users belong.',
    '#title' => t('LDAP Group Name'),
    '#attributes' => array('placeholder' => 'cn=group,dc=domain,dc=com'),
    '#default_value' =>\Drupal::config('ldap_auth.settings')->get('miniorange_ldap_enable_tls'),
);
$form['miniorange_ldap_enable_groudrupal_p_name'] = array(
  '#type' => 'textfield',
  '#prefix' => "<td><div class='subdiv_ui'>",
  '#suffix' => "</div></td>",
  '#disabled' => true,
  '#title' => t('Drupal Role'),
  //'#attributes' => array('placeholder' => 'cn=group,dc=domain,dc=com'),
  //'#default_value' =>\Drupal::config('ldap_auth.settings')->get('miniorange_ldap_enable_tls'),
);
$form['miniorange_ldap_add_mapping_settings']= array(
  '#prefix' => "<td><div class='subdiv_ui'>",
  '#suffix' => "</div></td>",
  '#markup' => "<div class ='subdiv_ui'>
  <div id='base_Url' name='base_Url' data='". $base_url."'></div>
 <a id='ping_server' class='btn btn-primary btn-sm' disabled style='padding:6px 12px;'>+</a>
  </div>",
);
            $form['miniorange_ldap_del_mapping_settings']= array(
              '#prefix' => "<td><div class='subdiv_ui'>",
  '#suffix' => "</div></td></tr></table>",
              '#markup' => "<div class ='subdiv_ui'>
              <div id='base_Url' name='base_Url' data='". $base_url."'></div>
             <a id='ping_server' class='btn btn-primary btn-sm' disabled style='padding:6px 12px;'>-</a>
              </div>",
            );
$form['miniorange_ldap_enable_group_attr_name'] = array(
  '#type' => 'textfield',
  '#prefix' => "<div class='subdiv_ui'>",
  '#suffix' => "</div>",
  '#disabled' => true,
  '#title' => t('LDAP Group Attribute Name: '),
  '#attributes' => array('placeholder' => 'memberOf'),
  //'#default_value' =>\Drupal::config('ldap_auth.settings')->get('miniorange_ldap_enable_tls'),
);

//            <input type='button' disabled style='background-color: #008CBA;border: none;color: white;padding: 8px 20px;text-align: center;text-decoration: none;display: inline-block;border-radius: 12px;font-size: 16px;' value='-' onclick='del()'>

$form['miniorange_ldap_save_mapping_settings']= array(
  '#markup' => "<div class ='subdiv_ui'>
  <div id='base_Url' name='base_Url' data='". $base_url."'></div>
 <a id='ping_server' class='btn btn-primary btn-sm' disabled style='padding:6px 12px;'>Save Mapping</a>
  </div>",
);
        return $form;
  }
  public function submitForm(array &$form, \Drupal\Core\Form\FormStateInterface $form_state)
  {

  }
}